// ローンシミュレーション（繰上返済時の返済金額算出） ver1.0
// 
// E-Mail: info@sitetool.biz
// Web   : http://www.sitetool.biz
// (C) 不動産WEBサイトツール
// 
// 上記著作権表示部は改変不可です。
// その他スクリプト部分は改変可です。

var kuriage = Class.create({
    initialize: function(elm) {
        
        // エラー格納用変数
        this.errors = [];
        this.error_elm = '';
        
        // 出力エリアのID
        this.elm = elm;
        
        // 計算結果格納用
        this.results = {};
        
        // 入力フォームを出力
        this.putForm();
        // イベントリスナ登録
        this.setEventHandlers();
    },
    // イベントリスナ
    setEventHandlers: function() {
        // ボタン
        this.clearHandler = this.clearForm.bind(this);
        $('fwt_clear').observe('click', this.clearHandler);
        this.calcHandler = this.calcForm.bind(this);
        $('fwt_calc').observe('click', this.calcHandler);
        this.showDetailHandler = this.showDetail.bind(this);
        $('fwt_show_detail').observe('click', this.showDetailHandler);
        this.goTopHandler = this.goTop.bind(this);
        $('fwt_gotop').observe('click', this.goTopHandler);
        // 返済期間
        this.changeDebtRateYearHandler = this.changeDebtRateYear.bind(this);
        $('fwt_borrow_year').observe('change', this.changeDebtRateYearHandler);
    },
    showDetail: function() {
        $('fwt_detail_results').style.display = 'block';
        window.scroll(0,400);
    },
    hideDetail: function() {
        $('fwt_detail_results').style.display = 'none';
        window.scroll(0,400);
    },
    goTop: function() {
        window.scroll(0,0);
    },
    // 各種計算と結果出力
    calcForm: function() {
        this.hideDetail();
        this.clearResult();
        this.calcBegin();
        this.checkForm();
        if(this.errors.length > 0) {
            this.alerts();
        }
        else {
            // 各値をキャスト
            var values = {};
            values['fwt_borrow_money'] = parseInt($('fwt_borrow_money').value*10000);
            values['fwt_borrow_bonus_rate'] = parseFloat($('fwt_borrow_bonus_rate').value/100);
            values['fwt_borrow_bonus'] = parseInt($('fwt_borrow_bonus').value*10000);
            values['fwt_borrow_year'] = parseInt($('fwt_borrow_year').value);
            values['fwt_debt_rate1'] = parseFloat($('fwt_debt_rate1').value/100);
            values['fwt_advance_year'] = parseInt($('fwt_advance_year').value);
            values['fwt_advance_money'] = parseInt($('fwt_advance_money').value*10000);
            
            // 出力用変数（共通分）
            values['fwt_pay_money1'] = 0;
            values['fwt_pay_bonus1'] = 0;
            values['fwt_pay_total']  = 0;
            values['fwt_pay_money_total']  = 0;
            values['fwt_pay_bonus_total']  = 0;
            values['fwt_pay_money1_after'] = 0;
            values['fwt_pay_bonus1_after'] = 0;
            values['fwt_pay_total_after']  = 0;
            values['fwt_pay_money_total_after']  = 0;
            values['fwt_pay_bonus_total_after']  = 0;
            values['fwt_pay_money_total_after_part']  = 0;
            values['fwt_pay_bonus_total_after_part']  = 0;
            values['fwt_advance_cnt_money'] = 0;
            values['fwt_advance_cnt_bonus'] = 0;
            
            // 月払分とボーナス払分に分ける
            if(values['fwt_borrow_bonus'] > 0) {
                values['fwt_borrow_money'] -= values['fwt_borrow_bonus'];
            }
            else if(values['fwt_borrow_bonus_rate']) {
                values['fwt_borrow_bonus'] = Math.round(values['fwt_borrow_money'] * values['fwt_borrow_bonus_rate']);
                values['fwt_borrow_money'] -= values['fwt_borrow_bonus'];
            }
            
            // 繰上返済分を月払分とボーナス払分に分ける
            if(values['fwt_borrow_bonus'] > 0) {
                values['fwt_advance_bonus'] = values['fwt_borrow_bonus'] / (values['fwt_borrow_money'] + values['fwt_borrow_bonus']) * values['fwt_advance_money'];
                values['fwt_advance_money'] = values['fwt_borrow_money'] / (values['fwt_borrow_money'] + values['fwt_borrow_bonus']) * values['fwt_advance_money'];
            }
            else {
                values['fwt_advance_bonus'] = 0;
            }
            
            if($('fwt_pay_type2').checked == true) {
                this.results = this.calcGankinKintou(values);
                // 結果出力
                this.putResults();
            }
            else {
                this.results = this.calcGanriKintou(values);
                // 結果出力
                this.putResults();
            }
            
        }
    },
    // 元金均等
    calcGankinKintou: function(values) {
        
        // ******************** 繰上げ返済がなかった場合の試算を行う ********************
        
        // 定額支払（月払分）
        values['pay_money_flat'] = Math.round(values['fwt_borrow_money'] / (values['fwt_borrow_year'] * 12));
        // 定額支払（ボーナス払分）
        values['pay_bonus_flat'] = Math.round(values['fwt_borrow_bonus'] / (values['fwt_borrow_year'] * 2));
        
        // 月明細
        values['pay_money_months'] = new Array();
        values['fwt_borrow_money_balance'] = values['fwt_borrow_money'];
        values['pay_bonus_months'] = new Array();
        values['fwt_borrow_bonus_balance'] = values['fwt_borrow_bonus'];
        for(var i=1; i <= values['fwt_borrow_year']; i++) {
            values['pay_money_months'][i] = new Array();
            values['pay_bonus_months'][i] = new Array();
            for(var j=1; j<=12; j++) {
                values['pay_money_months'][i][j] = Math.round(values['fwt_borrow_money_balance'] * (values['fwt_debt_rate1'] / 12) + values['pay_money_flat']);
                values['fwt_pay_money_total'] += values['pay_money_months'][i][j];
                values['fwt_borrow_money_balance'] -= values['pay_money_flat'];
                
                values['pay_bonus_months'][i][j] = 0;
                if(j == 6 || j == 12) {
                    values['pay_bonus_months'][i][j] = Math.round(values['fwt_borrow_bonus_balance'] * (values['fwt_debt_rate1'] / 2) + values['pay_bonus_flat']);
                    values['fwt_pay_bonus_total'] += values['pay_bonus_months'][i][j];
                    values['fwt_borrow_bonus_balance'] -= values['pay_bonus_flat'];
                }
            }
            
        }
        
        // 総額
        values['fwt_pay_total']  = values['fwt_pay_money_total'] + values['fwt_pay_bonus_total'];
        
        
        // 繰上返済:元金均等:期間短縮型
        if($('fwt_advance_type1').checked == true) {
            
            values['fwt_pay_type'] = 1;
            
            // ******************** 繰上返済による軽減回数と軽減利息を取得しつつ新たな月詳細を作成 ********************
            
            // 余りが定額払いの50%以上なら繰上減額、未満なら増額
            var remain_money = values['fwt_advance_money'] % values['pay_money_flat'];
            if(remain_money / values['pay_money_flat'] <= 0.5) {
                values['fwt_advance_money'] -= remain_money;
            }
            else {
                values['fwt_advance_money'] += values['pay_money_flat'] - remain_money;
            }
            // 軽減回数
            values['fwt_advance_cnt_money'] = values['fwt_advance_money'] / values['pay_money_flat'];
            
            if(values['fwt_advance_bonus'] > 0) {
                var remain_bonus = values['fwt_advance_bonus'] % values['pay_bonus_flat'];
                if(remain_bonus / values['pay_bonus_flat'] <= 0.5) {
                    values['fwt_advance_bonus'] -= remain_bonus;
                }
                else {
                    values['fwt_advance_bonus'] += values['pay_bonus_flat'] - remain_bonus;
                }
                // 軽減回数
                values['fwt_advance_cnt_bonus'] = values['fwt_advance_bonus'] / values['pay_bonus_flat'];
            }
            
            
            // 明細
            var cnt_money = 1;
            var start_money = (values['fwt_advance_year']-1) * 12;
            var end_money = start_money + values['fwt_advance_cnt_money'];
            var y = 1;
            var m = 1;
            values['pay_money_months_after'] = new Array();
            values['pay_money_months_after'][1] = new Array();
            
            var cnt_bonus = 1;
            var start_bonus = (values['fwt_advance_year']-1) * 12 / 2;
            var end_bonus = start_bonus + values['fwt_advance_cnt_bonus'];
            var yb = 1;
            var mb = 1;
            values['pay_bonus_months_after'] = new Array();
            values['pay_bonus_months_after'][1] = new Array();
            
            
            for(var i=1; i <= values['fwt_borrow_year']; i++) {
                for(var j=1; j<=12; j++) {
                    // 月払い分
                    if(cnt_money <= start_money || cnt_money > end_money) {
                        // 繰上返済以前は元々の支払を代入して月数アップ
                        values['pay_money_months_after'][y][m] = values['pay_money_months'][i][j];
                        values['fwt_pay_money_total_after'] += values['pay_money_months_after'][y][m];
                        m++;
                    }
                    cnt_money++;
                    
                    // ボーナス分
                    if(cnt_bonus <= start_bonus || cnt_bonus > end_bonus) {
                        // 繰上返済以前は元々の支払を代入して月数アップ
                        values['pay_bonus_months_after'][yb][mb] = values['pay_bonus_months'][i][j];
                        values['fwt_pay_bonus_total_after'] += values['pay_bonus_months_after'][yb][mb];
                        mb++;
                    }
                    if(j == 6 || j == 12) {
                        cnt_bonus++;
                    }
                    
                    // 年アップ
                    if(m > 12) {
                        y++;
                        m = 1;
                        values['pay_money_months_after'][y] = new Array();
                    }
                    if(mb > 12) {
                        yb++;
                        mb = 1;
                        values['pay_bonus_months_after'][yb] = new Array();
                    }
                }
            }
            
            values['fwt_pay_total_after'] = values['fwt_pay_money_total_after'] + values['fwt_pay_bonus_total_after'] + values['fwt_advance_money'] + values['fwt_advance_bonus'];
        }
        // 繰上返済:元金均等:返済額軽減型
        else if($('fwt_advance_type2').checked == true) {
        
            // ******************** 繰上げ返済を実施して繰上直後の残元金を改めて借入金としてセット ********************
            values['fwt_borrow_money_after'] = values['fwt_borrow_money'];
            values['fwt_borrow_bonus_after'] = values['fwt_borrow_bonus'];
            for(var i=1; i < values['fwt_advance_year']; i++) {
                for(var j=1; j<=12; j++) {
                    values['fwt_borrow_money_after'] -= values['pay_money_flat'];
                    if(j == 6 || j == 12) {
                        values['fwt_borrow_bonus_after'] -= values['pay_bonus_flat'];
                    }
                    // 繰上げ返済実施
                    if(i == values['fwt_advance_year']-1 && j == 12) {
                        values['fwt_borrow_money_after'] -= values['fwt_advance_money'];
                        values['fwt_borrow_bonus_after'] -= values['fwt_advance_bonus'];
                        break;
                    }
                }
                if(i == values['fwt_advance_year']-1 && j == 12) {
                    break;
                }
            }
            
            // ******************** 繰上げ返済後を初回として試算を行う ********************
            
            // 各種条件を再設定
            values['fwt_borrow_year_after'] = values['fwt_borrow_year'] - values['fwt_advance_year'] + 1;
            
            // 定額支払（月払分）
            values['pay_money_flat_after'] = Math.round(values['fwt_borrow_money_after'] / (values['fwt_borrow_year_after'] * 12));
            // 定額支払（ボーナス払分）
            values['pay_bonus_flat_after'] = Math.round(values['fwt_borrow_bonus_after'] / (values['fwt_borrow_year_after'] * 2));
            
            // 繰上後の月ごと支払を作成
            values['pay_money_months_after_part'] = new Array();
            values['pay_bonus_months_after_part'] = new Array();
            var fwt_borrow_money_balance_after = values['fwt_borrow_money_after'];
            var fwt_borrow_bonus_balance_after = values['fwt_borrow_bonus_after'];
            for(var i=1; i <= values['fwt_borrow_year_after']; i++) {
                values['pay_money_months_after_part'][i] = new Array();
                values['pay_bonus_months_after_part'][i] = new Array();
                for(var j=1; j<=12; j++) {
                    values['pay_money_months_after_part'][i][j] = Math.round(fwt_borrow_money_balance_after * (values['fwt_debt_rate1'] / 12) + values['pay_money_flat_after']);
                    fwt_borrow_money_balance_after -= values['pay_money_flat_after'];
                    
                    values['pay_bonus_months_after_part'][i][j] = 0;
                    if(j == 6 || j == 12) {
                        values['pay_bonus_months_after_part'][i][j] = Math.round(fwt_borrow_bonus_balance_after * (values['fwt_debt_rate1'] / 2) + values['pay_bonus_flat_after']);
                        fwt_borrow_bonus_balance_after -= values['pay_bonus_flat_after'];
                    }
                }
                
            }
            
            // 繰上前後を合わせる
            var ii = 0;
            values['pay_money_months_after'] = new Array();
            values['pay_bonus_months_after'] = new Array();
            for(var i=1; i <= values['fwt_borrow_year']; i++) {
                values['pay_money_months_after'][i] = new Array();
                values['pay_bonus_months_after'][i] = new Array();
                if(i < values['fwt_advance_year']) {
                    for(var j=1; j<=12; j++) {
                        values['pay_money_months_after'][i][j] = values['pay_money_months'][i][j];
                        values['fwt_pay_money_total_after'] += values['pay_money_months_after'][i][j];
                        values['pay_bonus_months_after'][i][j] = values['pay_bonus_months'][i][j];
                        values['fwt_pay_bonus_total_after'] += values['pay_bonus_months_after'][i][j];
                    }
                }
                else {
                    ii = i - values['fwt_advance_year']+1;
                    for(var j=1; j<=12; j++) {
                        values['pay_money_months_after'][i][j] = values['pay_money_months_after_part'][ii][j];
                        values['fwt_pay_money_total_after'] += values['pay_money_months_after'][i][j];
                        values['pay_bonus_months_after'][i][j] = values['pay_bonus_months_after_part'][ii][j];
                        values['fwt_pay_bonus_total_after'] += values['pay_bonus_months_after'][i][j];
                    }
                }
            }
            // 返済総額
            values['fwt_pay_total_after'] = values['fwt_pay_money_total_after'] + values['fwt_advance_money'] + values['fwt_pay_bonus_total_after'] + values['fwt_advance_bonus'];
            
        }
        
        return values;
    },
    // 元利均等
    calcGanriKintou: function(values) {
        
        // ******************** 繰上げ返済がなかった場合の試算を行う ********************
        
        // 予定利率(1)の返済額を求める（月額＆ボーナス）
        values['fwt_pay_money1'] = Math.round(values['fwt_borrow_money'] * values['fwt_debt_rate1']/12 * Math.pow(1+values['fwt_debt_rate1']/12,values['fwt_borrow_year']*12) / (Math.pow((1+values['fwt_debt_rate1']/12),(values['fwt_borrow_year']*12))-1));
        values['fwt_pay_bonus1'] = Math.round(values['fwt_borrow_bonus'] * values['fwt_debt_rate1']/2 * Math.pow(1+values['fwt_debt_rate1']/2,values['fwt_borrow_year']*2) / (Math.pow((1+values['fwt_debt_rate1']/2),(values['fwt_borrow_year']*2))-1));
        
        // 月ごと支払を作成
        values['pay_money_months'] = new Array();
        values['pay_bonus_months'] = new Array();
        for(var i=1; i <= values['fwt_borrow_year']; i++) {
            values['pay_money_months'][i] = new Array();
            values['pay_bonus_months'][i] = new Array();
            for(var j=1; j<=12; j++) {
                values['pay_money_months'][i][j] = values['fwt_pay_money1'];
                values['fwt_pay_money_total'] += values['fwt_pay_money1'];
                values['pay_bonus_months'][i][j] = 0;
                if(j == 6 || j == 12) {
                    values['pay_bonus_months'][i][j] = values['fwt_pay_bonus1'];
                    values['fwt_pay_bonus_total'] += values['fwt_pay_bonus1'];
                }
            }
        }
        
        // 返済総額
        values['fwt_pay_total'] = values['fwt_pay_money_total'] + values['fwt_pay_bonus_total'];
        
        // 繰上返済:元利均等:期間短縮型
        if($('fwt_advance_type1').checked == true) {
            
            values['fwt_pay_type'] = 1;
            
            // ******************** 繰上げ返済による軽減回数を取得 ********************
            
            // 月払い分
            
            // 直前の回数
            var fwt_advance_money_cnt = values['fwt_advance_year'] * 12 -12;
            // 直前の元金残
            var fwt_borrow_money_temp = (values['fwt_pay_money1'] - Math.pow(1+values['fwt_debt_rate1']/12,fwt_advance_money_cnt) * (values['fwt_pay_money1'] - values['fwt_borrow_money'] * values['fwt_debt_rate1']/12)) / (values['fwt_debt_rate1']/12);
            // 繰上返済後の元金
            var fwt_borrow_money = fwt_borrow_money_temp - values['fwt_advance_money'];
            // 繰上後回数
            values['fwt_advance_cnt_money_temp'] = Math.round(Math.log(values['fwt_pay_money1']/(values['fwt_pay_money1']-fwt_borrow_money*values['fwt_debt_rate1']/12))/Math.log(1+values['fwt_debt_rate1']/12));
            // 繰上後回数から借入可能金額（元金）算出
            var fwt_borrow_money_temp2 = values['fwt_pay_money1']*(Math.pow((1+values['fwt_debt_rate1']/12),values['fwt_advance_cnt_money_temp'])-1)/(values['fwt_debt_rate1']/12*Math.pow((1+values['fwt_debt_rate1']/12),values['fwt_advance_cnt_money_temp']));
            // 元金差を繰上に加算
            values['fwt_advance_money'] += fwt_borrow_money - fwt_borrow_money_temp2;
            // 軽減回数
            values['fwt_advance_cnt_money'] = values['fwt_borrow_year'] * 12 - (fwt_advance_money_cnt + values['fwt_advance_cnt_money_temp']);

            // ボーナス分
            
            // 直前の回数
            var fwt_advance_bonus_cnt = values['fwt_advance_year'] * 2 - 2;
            if(values['fwt_advance_bonus'] > 0) {
                // 直前の元金残
                var fwt_borrow_bonus_temp = (values['fwt_pay_bonus1'] - Math.pow(1+values['fwt_debt_rate1']/2,fwt_advance_bonus_cnt) * (values['fwt_pay_bonus1'] - values['fwt_borrow_bonus'] * values['fwt_debt_rate1']/2)) / (values['fwt_debt_rate1']/2);
                // 繰上返済後の元金
                var fwt_borrow_bonus = fwt_borrow_bonus_temp - values['fwt_advance_bonus'];
                // 繰上後回数
                values['fwt_advance_cnt_bonus_temp'] = Math.round(Math.log(values['fwt_pay_bonus1']/(values['fwt_pay_bonus1']-fwt_borrow_bonus*values['fwt_debt_rate1']/2))/Math.log(1+values['fwt_debt_rate1']/2));
                // 繰上後回数から借入可能金額（元金）算出
                var fwt_borrow_bonus_temp2 = values['fwt_pay_bonus1']*(Math.pow((1+values['fwt_debt_rate1']/2),values['fwt_advance_cnt_bonus_temp'])-1)/(values['fwt_debt_rate1']/2*Math.pow((1+values['fwt_debt_rate1']/2),values['fwt_advance_cnt_bonus_temp']));
                // 元金差を繰上に加算
                values['fwt_advance_bonus'] += fwt_borrow_bonus - fwt_borrow_bonus_temp2;
                // 軽減回数
                values['fwt_advance_cnt_bonus'] = values['fwt_borrow_year'] * 2 - (fwt_advance_bonus_cnt + values['fwt_advance_cnt_bonus_temp']);
            }
            
            
            
            // 明細
            values['pay_money_months_after'] = new Array();
            values['pay_bonus_months_after'] = new Array();
            var cnt_money = 1;
            var cnt_bonus = 1;
            for(var i=1; i <= values['fwt_borrow_year']; i++) {
                
                values['pay_money_months_after'][i] = new Array();
                values['pay_bonus_months_after'][i] = new Array();
                
                for(var j=1; j<=12; j++) {
                    
                    values['pay_money_months_after'][i][j] = 0;
                    if(cnt_money <= fwt_advance_money_cnt + values['fwt_advance_cnt_money_temp']) {
                        values['pay_money_months_after'][i][j] = values['fwt_pay_money1'];
                        values['fwt_pay_money_total_after'] += values['pay_money_months_after'][i][j];
                    }
                    cnt_money++;
                    
                    values['pay_bonus_months_after'][i][j] = 0;
                    if(j == 6 || j == 12) {
                        if(cnt_bonus <= fwt_advance_bonus_cnt + values['fwt_advance_cnt_bonus_temp']) {
                            values['pay_bonus_months_after'][i][j] = values['fwt_pay_bonus1'];
                            values['fwt_pay_bonus_total_after'] += values['pay_bonus_months_after'][i][j];
                        }
                        cnt_bonus++;
                    }
                }
            }
            
            values['fwt_pay_total_after'] = values['fwt_pay_money_total_after'] + values['fwt_pay_bonus_total_after'] + values['fwt_advance_money'] + values['fwt_advance_bonus'];
        }
        // 繰上返済:元利均等:返済額軽減型
        else if($('fwt_advance_type2').checked == true) {
        
            // ******************** 繰上げ返済を実施して繰上直後の残元金を改めて借入金としてセット ********************
            values['fwt_borrow_money_after'] = values['fwt_borrow_money'];
            values['fwt_borrow_bonus_after'] = values['fwt_borrow_bonus'];
            for(var i=1; i < values['fwt_advance_year']; i++) {
                for(var j=1; j<=12; j++) {
                    values['fwt_borrow_money_after'] = (values['pay_money_months'][i][j] - Math.pow(1+values['fwt_debt_rate1']/12,1) * (values['pay_money_months'][i][j] - values['fwt_borrow_money_after'] * values['fwt_debt_rate1']/12)) / (values['fwt_debt_rate1']/12);
                    if(values['pay_bonus_months'][i][j] > 0) {
                        values['fwt_borrow_bonus_after'] = (values['pay_bonus_months'][i][j] - Math.pow(1+values['fwt_debt_rate1']/2,1) * (values['pay_bonus_months'][i][j] - values['fwt_borrow_bonus_after'] * values['fwt_debt_rate1']/2)) / (values['fwt_debt_rate1']/2);
                    }
                }
            }
            
            values['fwt_borrow_money_after'] -= values['fwt_advance_money'];
            values['fwt_borrow_bonus_after'] -= values['fwt_advance_bonus'];
            
            // ******************** 繰上げ返済後を初回として試算を行う ********************
            
            // 各種条件を再設定
            values['fwt_borrow_year_after'] = values['fwt_borrow_year'] - values['fwt_advance_year'] + 1;
            
            // 予定利率(1)の返済額を求める（月額＆ボーナス）
            values['fwt_pay_money1_after'] = Math.round(values['fwt_borrow_money_after'] * values['fwt_debt_rate1']/12 * Math.pow(1+values['fwt_debt_rate1']/12,values['fwt_borrow_year_after']*12) / (Math.pow((1+values['fwt_debt_rate1']/12),(values['fwt_borrow_year_after']*12))-1));
            values['fwt_pay_bonus1_after'] = Math.round(values['fwt_borrow_bonus_after'] * values['fwt_debt_rate1']/2 * Math.pow(1+values['fwt_debt_rate1']/2,values['fwt_borrow_year_after']*2) / (Math.pow((1+values['fwt_debt_rate1']/2),(values['fwt_borrow_year_after']*2))-1));
            
            // 繰上後の月ごと支払を作成
            values['pay_money_months_after_part'] = new Array();
            values['pay_bonus_months_after_part'] = new Array();
            for(var i=1; i <= values['fwt_borrow_year_after']; i++) {
                values['pay_money_months_after_part'][i] = new Array();
                values['pay_bonus_months_after_part'][i] = new Array();
                for(var j=1; j<=12; j++) {
                    values['pay_money_months_after_part'][i][j] = values['fwt_pay_money1_after'];
                    values['fwt_pay_money_total_after_part'] += values['fwt_pay_money1_after'];
                    
                    values['pay_bonus_months_after_part'][i][j] = 0;
                    if(j == 6 || j == 12) {
                        values['pay_bonus_months_after_part'][i][j] = values['fwt_pay_bonus1_after'];
                        values['fwt_pay_bonus_total_after_part'] += values['fwt_pay_bonus1_after'];
                    }
                    
                }
            }

            // 繰上前後を合わせる
            values['pay_money_months_after'] = new Array();
            values['pay_bonus_months_after'] = new Array();
            for(var i=1; i <= values['fwt_borrow_year']; i++) {
                values['pay_money_months_after'][i] = new Array();
                values['pay_bonus_months_after'][i] = new Array();
                if(i < values['fwt_advance_year']) {
                    for(var j=1; j<=12; j++) {
                        values['pay_money_months_after'][i][j] = values['pay_money_months'][i][j];
                        values['fwt_pay_money_total_after'] += values['pay_money_months_after'][i][j];
                        
                        values['pay_bonus_months_after'][i][j] = 0;
                        if(j == 6 || j == 12) {
                            values['pay_bonus_months_after'][i][j] = values['pay_bonus_months'][i][j];
                            values['fwt_pay_bonus_total_after'] += values['pay_bonus_months_after'][i][j];
                        }
                    }
                }
                else {
                    var ii = i - values['fwt_advance_year']+1;
                    for(var j=1; j<=12; j++) {
                        values['pay_money_months_after'][i][j] = values['pay_money_months_after_part'][ii][j];
                        values['fwt_pay_money_total_after'] += values['pay_money_months_after'][i][j];
                        
                        values['pay_bonus_months_after'][i][j] = 0;
                        if(j == 6 || j == 12) {
                            values['pay_bonus_months_after'][i][j] = values['pay_bonus_months_after_part'][ii][j];
                            values['fwt_pay_bonus_total_after'] += values['pay_bonus_months_after'][i][j];
                        }
                    }
                }
            }
            // 返済総額
            values['fwt_pay_total_after'] = values['fwt_pay_money_total_after'] + values['fwt_pay_bonus_total_after'] + values['fwt_advance_money'] + values['fwt_advance_bonus'];
        }
        
        return values;
    },
    // 入力フォーム出力
    putForm: function() {
        var html = '';
        html += '<p id="fwt_caption_input">借入金額から毎月の返済金額をシミュレーションします</p>';
        html += '<div id="fwt_explane">';
        html += '<p>※下記フォームを入力し、「計算」ボタンをクリックしてください。</p>';
        html += '<p>※計算結果は概算です。あくまで参考としてご利用ください。</p>';
        html += '</div>';
        html += '<form name="fwt_kuriageForm" id="fwt_kuriageForm">';
        html += '<div id="fwt_inputs">';
        html += '<table>';
        html += '<tr>';
        html += '<th>借入予定金額<span class="fwt_need">必須</span></th>';
        html += '<td><input type="text" name="fwt_borrow_money" id="fwt_borrow_money" value="" size="10" /> 万円<div class="fwt_note">1～999999</div></td>';
        html += '</tr>';
        html += '<tr>';
        html += '<th>内、ボーナスで返済する割合又は金額</th>';
        html += '<td>'+this.makeBorrowBonusRate('fwt_borrow_bonus_rate')+' ％ 又は <input type="text" name="fwt_borrow_bonus" id="fwt_borrow_bonus" value="" size="10" /> 万円<div class="fwt_note">1～999999</div></td>';
        html += '</tr>';
        html += '<tr>';
        html += '<th>返済期間<span class="fwt_need">必須</span></th>';
        html += '<td>'+this.makeBorrowYear('fwt_borrow_year')+' 年</td>';
        html += '</tr>';
        html += '<tr>';
        html += '<th>金利<span class="fwt_need">必須</span></th>';
        html += '<td><input type="text" name="fwt_debt_rate1" id="fwt_debt_rate1" value="" size="10" /> ％<div class="fwt_note">0.01～99.99</div></td>';
        html += '</tr>';
        html += '<tr>';
        html += '<th>返済方式</th>';
        html += '<td><input type="radio" name="fwt_pay_type" id="fwt_pay_type1" value="1" checked="checked" /><label for="fwt_pay_type1"> 元利均等</label><input type="radio" name="fwt_pay_type" id="fwt_pay_type2" value="2" /><label for="fwt_pay_type2"> 元金均等</label></td>';
        html += '</tr>';
        html += '<tr>';
        html += '<th>繰上返済予定<span class="fwt_need">必須</span></th>';
        html += '<td>'+this.makeAdvanceYear('fwt_advance_year')+' 年後</td>';
        html += '</tr>';
        html += '<tr>';
        html += '<th>繰上返済予定金額<span class="fwt_need">必須</span></th>';
        html += '<td><input type="text" name="fwt_advance_money" id="fwt_advance_money" value="" size="10" /> 万円<div class="fwt_note">1～999999</div></td>';
        html += '</tr>';
        html += '<tr>';
        html += '<th>繰上方式</th>';
        html += '<td><input type="radio" name="fwt_advance_type" id="fwt_advance_type1" value="1" checked="checked" /><label for="fwt_advance_type1"> 期間短縮型</label><input type="radio" name="fwt_advance_type" id="fwt_advance_type2" value="2" /><label for="fwt_advance_type2"> 返済額軽減型</label></td>';
        html += '</tr>';
        html += '<tr>';
        html += '<td colspan="2"><div id="fwt_buttons"><input type="button" name="fwt_clear" id="fwt_clear" value="クリア" /> <input type="button" name="fwt_calc" id="fwt_calc" value="計算" /></div></td>';
        html += '</tr>';
        html += '</table>';
        html += '</div>';
        html += '<div id="fwt_results">';
        html += '</div>';
        html += '<div id="fwt_buttons2"><input type="button" name="fwt_show_detail" id="fwt_show_detail" value="さらに月別返済を詳細表示する" /></div>';
        html += '<div id="fwt_detail_results">';
        html += '</div>';
        html += '<div id="fwt_gotop"><a href="javascript:void(0);">↑ページ上へ戻る</a></div>';
        html += '</form>';
        Element.update($(this.elm),html);
    },
    // 入力フォームのボーナス返済率
    makeBorrowBonusRate: function(name) {
        var html = '';
        if(name) {
            html += '<select name="'+name+'" id="'+name+'">';
            html += '<option value=""></option>';
            for(var i=0; i<=100; i=i+5) {
                html += '<option value="'+i+'">'+i+'</option>';
            }
            html += '</select>';
        }
        return html;
    },
    // 繰上返済予定（年）
    makeAdvanceYear: function(name) {
        var html = '';
        if(name) {
            html += '<select name="'+name+'" id="'+name+'">';
            for(var i=0; i<=40; i++) {
                if(i == 5) {
                    html += '<option value="'+i+'" selected="selected">'+i+'</option>';
                }
                else {
                    html += '<option value="'+i+'">'+i+'</option>';
                }
            }
            html += '</select>';
        }
        return html;
    },
    // 入力フォームの返済期間選択肢（年）
    makeBorrowYear: function(name) {
        var html = '';
        if(name) {
            html += '<select name="'+name+'" id="'+name+'">';
            for(var i=1; i<=40; i++) {
                if(i == 25) {
                    html += '<option value="'+i+'" selected="selected">'+i+'</option>';
                }
                else {
                    html += '<option value="'+i+'">'+i+'</option>';
                }
            }
            html += '</select>';
        }
        return html;
    },
    // 結果出力
    putResults: function() {
        
        var fwt_borrow_year_bonus = 0;
        if(this.results['fwt_pay_bonus_total'] > 0) {
            fwt_borrow_year_bonus = this.results['fwt_borrow_year']*2;
        }
        
        var fwt_pay_money_total = Math.round(this.results['fwt_pay_money_total']/10000);
        var fwt_pay_bonus_total = Math.round(this.results['fwt_pay_bonus_total']/10000);
        var fwt_pay_money_total_after = Math.round((this.results['fwt_pay_money_total_after']+this.results['fwt_advance_money'])/10000);
        var fwt_pay_bonus_total_after = Math.round((this.results['fwt_pay_bonus_total_after']+this.results['fwt_advance_bonus'])/10000);
        
        var fwt_remain_money = fwt_pay_money_total - fwt_pay_money_total_after;
        var fwt_remain_bonus = fwt_pay_bonus_total - fwt_pay_bonus_total_after;
        
        var fwt_advance_money = (Math.round(this.results['fwt_advance_money']/1000)/10);
        var fwt_advance_bonus = (Math.round(this.results['fwt_advance_bonus']/1000)/10);
        var fwt_advance_total = Math.round(fwt_advance_money+fwt_advance_bonus);
        if(this.results['fwt_pay_type'] == 1) {
            var fwt_advance_total = Math.round((fwt_advance_money+fwt_advance_bonus)*10)/10;
        }
        
        var html = '';
        html += '<p id="fwt_caption_result">シミュレーション結果</p>';
        html += '<div id="fwt_pays">';
        html += '<div id="fwt_advance">';
        html += '<table>';
        html += '<tr>';
        html += '<th>&nbsp;</th>';
        html += '<th>繰上返済時期</th>';
        html += '<th>繰上返済金額</th>';
        html += '</tr>';
        html += '<tr>';
        html += '<td>月払分</td>';
        html += '<td>'+this.results['fwt_advance_year']+'年目の1ヶ月目</td>';
        html += '<td>'+fwt_advance_money+' 万円</td>';
        html += '</tr>';
        html += '<tr>';
        html += '<td>ボーナス払分</td>';
        html += '<td>'+this.results['fwt_advance_year']+'年目の1ヶ月目</td>';
        html += '<td>'+fwt_advance_bonus+' 万円</td>';
        html += '</tr>';
        html += '<tr>';
        html += '<td>計</td>';
        html += '<td>&nbsp;</td>';
        html += '<td><div id="fwt_advance_total">'+fwt_advance_total+' 万円</div></td>';
        html += '</tr>';
        html += '</table>';
        html += '</div>';
        html += '<table>';
        html += '<tr>';
        html += '<th>&nbsp;</th><th>繰上なし返済額</th><th>繰上あり返済額</th><th>利息軽減額</th>';
        html += '</tr>';
        html += '<tr>';
        html += '<td>月払</td><td>'+this.addComma(fwt_pay_money_total)+' 円</td><td>'+this.addComma(fwt_pay_money_total_after)+' 万円</td><td>'+this.addComma(fwt_remain_money)+' 万円</td>';
        html += '</tr>';
        html += '<tr>';
        html += '<td>ボーナス払</td><td>'+this.addComma(fwt_pay_bonus_total)+' 円</td><td>'+this.addComma(fwt_pay_bonus_total_after)+' 万円</td><td>'+this.addComma(fwt_remain_bonus)+' 万円</td>';
        html += '</tr>';
        html += '<tr>';
        html += '<td>総額</td><td>'+this.addComma(Math.round(fwt_pay_money_total+fwt_pay_bonus_total))+' 円</td><td>'+this.addComma(Math.round(fwt_pay_money_total_after+fwt_pay_bonus_total_after))+' 万円</td><td><div id="fwt_remain_total">'+this.addComma(Math.round(fwt_remain_money+fwt_remain_bonus))+' 万円</div></td>';
        html += '</tr>';
        html += '</table>';
        if(this.results['fwt_pay_type'] == 1) {
            html += '<table>';
            html += '<tr>';
            html += '<th>&nbsp;</th><th>繰上なし返済回数</th><th>繰上あり返済回数</th><th>軽減返済回数</th>';
            html += '</tr>';
            html += '<tr>';
            html += '<td>月払</td><td>'+this.addComma(Math.round(this.results['fwt_borrow_year']*12))+' 回</td><td>'+this.addComma(Math.round(this.results['fwt_borrow_year']*12-this.results['fwt_advance_cnt_money']))+' 回</td><td>'+this.addComma(this.results['fwt_advance_cnt_money'])+' 回</td>';
            html += '</tr>';
            html += '<tr>';
            html += '<td>ボーナス払</td><td>'+this.addComma(Math.round(fwt_borrow_year_bonus))+' 回</td><td>'+this.addComma(Math.round(fwt_borrow_year_bonus-this.results['fwt_advance_cnt_bonus']))+' 回</td><td>'+this.addComma(this.results['fwt_advance_cnt_bonus'])+' 回</td>';
            html += '</tr>';
            html += '</table>';
            html += '<table>';
            html += '<tr>';
            html += '<th>&nbsp;</th><th>繰上なし返済期間</th><th>繰上あり返済期間</th><th>軽減返済期間</th>';
            html += '</tr>';
            html += '<tr>';
            html += '<td>期間</td><td>'+this.addComma(Math.round(this.results['fwt_borrow_year']))+'年</td><td>'+this.addComma(parseInt((this.results['fwt_borrow_year']*12-this.results['fwt_advance_cnt_money'])/12))+'年'+(this.results['fwt_borrow_year']*12-this.results['fwt_advance_cnt_money'])%12+'ヶ月</td><td><div id="fwt_advance_year">'+this.addComma(parseInt(this.results['fwt_advance_cnt_money']/12))+'年'+this.results['fwt_advance_cnt_money']%12+'ヶ月</div></td>';
            html += '</tr>';
            html += '</table>';
        }
        html += '</div>';
        Element.update($('fwt_results'),html);
        
        // 詳細
        html = '<p id="fwt_caption_detail">月別返済（詳細）</p>';
        html = '<p>※ボーナスは各年6月・12月支払いとみなしています。</p>';
        
        var pay_total = 0;
        var pay_total_after = 0;
        var pay_total_month = 0;
        var pay_total_month_after = 0;
        
        for(var i=1; i <= this.results['fwt_borrow_year']; i++) {
            
            if(typeof this.results['pay_money_months_after'][i] == 'undefined') {
                this.results['pay_money_months_after'][i] = new Array();
                this.results['pay_bonus_months_after'][i] = new Array();
            }
            
            pay_total = 0;
            pay_total_after = 0;
            pay_total_month = 0;
            pay_total_month_after = 0;
            
            html += '<div class="fwt_caption_detail_table">'+i+'年目</div>';
            html += '<table>';
            html += '<tr>';
            html += '<th class="th1">&nbsp;</th><th class="th2">返済金額<br />（繰上なし）</th><th class="th2">返済金額<br />（繰上あり）</th><th class="th2">差額</th>';
            html += '</tr>';
            for(var j=1; j<=12; j++) {
                
                if(typeof this.results['pay_money_months_after'][i][j] == 'undefined') {
                    this.results['pay_money_months_after'][i][j] = 0;
                    this.results['pay_bonus_months_after'][i][j] = 0;
                }
                
                // 計
                pay_total = this.results['pay_money_months'][i][j] + this.results['pay_bonus_months'][i][j];
                pay_total_after = this.results['pay_money_months_after'][i][j] + this.results['pay_bonus_months_after'][i][j];
                
                // 月計
                pay_total_month += pay_total;
                pay_total_month_after += pay_total_after;
                
                if(i == this.results['fwt_advance_year'] && j == 1) {
                    html += '<tr id="advance_month">';
                    html += '<td>繰上</td><td>0 円</td><td>'+this.addComma(Math.round(this.results['fwt_advance_money'] + this.results['fwt_advance_bonus']))+' 円</td><td>'+this.addComma(Math.round(this.results['fwt_advance_money'] - this.results['fwt_advance_bonus']))+' 円</td>';
                    html += '</tr>';
                }
                html += '<tr>';
                html += '<td>'+j+'ヶ月目</td><td>'+this.addComma(pay_total)+' 円</td><td>'+this.addComma(pay_total_after)+' 円</td><td>'+this.addComma(pay_total_after-pay_total)+' 円</td>';
                html += '</tr>';
            }
            html += '<tr>';
            html += '<td>計</td><td>'+this.addComma(pay_total_month)+' 円</td><td>'+this.addComma(pay_total_month_after)+' 円</td><td>'+this.addComma(pay_total_month_after-pay_total_month)+' 円</td>';
            html += '</tr>';
            html += '</table>';
        }
        Element.update($('fwt_detail_results'),html);
        
        // 詳細表示用ボタン表示
        $('fwt_buttons2').style.display = 'block';
    },
    // 結果クリア
    clearResult: function() {
        Element.update($('fwt_results'),'');
        this.results = {};
    },
    // 入力値クリア
    clearForm: function() {
        $('fwt_borrow_money').value = '';
        $('fwt_borrow_bonus').value = '';
        $('fwt_borrow_bonus_rate').selectedIndex = 0;
        $('fwt_borrow_year').selectedIndex = 24;
        $('fwt_debt_rate1').value = '';
        $('fwt_pay_type1').checked = true;
        $('fwt_pay_type2').checked = false;
        $('fwt_advance_year').selectedIndex = 5;
        $('fwt_advance_money').value = '';
        $('fwt_advance_type1').checked = true;
        $('fwt_advance_type2').checked = false;
    },
    // 事前処理（計算・入力値チェックの前）
    calcBegin: function() {
        $('fwt_borrow_money').value = this.replaceZennumToHannum($('fwt_borrow_money').value);
        $('fwt_borrow_bonus_rate').value = this.replaceZennumToHannum($('fwt_borrow_bonus_rate').value);
        $('fwt_borrow_bonus').value = this.replaceZennumToHannum($('fwt_borrow_bonus').value);
        $('fwt_borrow_year').value = this.replaceZennumToHannum($('fwt_borrow_year').value);
        $('fwt_debt_rate1').value = this.replaceZennumToHannum($('fwt_debt_rate1').value);
        $('fwt_advance_year').value = this.replaceZennumToHannum($('fwt_advance_year').value);
        $('fwt_advance_money').value = this.replaceZennumToHannum($('fwt_advance_money').value);
    },
    // 入力値チェック
    checkForm: function() {
        this.errors = [];
        this.error_elm = '';
        var name = '';
        
        // 借入予定金額
        name = '「借入予定金額」';
        if($('fwt_borrow_money').value == '') {
            this.errors.push(name+'を入力してください。');
            this.errorFocus('fwt_borrow_money');
        }
        else {
            var err = this.checkNumber($('fwt_borrow_money').value,6,0);
            if(err) {
                this.errors.push(name+'は'+err);
                this.errorFocus('fwt_borrow_money');
            }
        }
        
        // 内、ボーナスで返済する金額
        name = '「内、ボーナスで返済する金額」';
        if($('fwt_borrow_bonus').value != '') {
            var err = this.checkNumber($('fwt_borrow_bonus').value,6,0);
            if(err) {
                this.errors.push(name+'は'+err);
                this.errorFocus('fwt_borrow_bonus');
            }
        }
        if($('fwt_borrow_bonus').value != '' && $('fwt_borrow_money').value != '') {
            if(parseInt($('fwt_borrow_bonus').value) > parseInt($('fwt_borrow_money').value)) {
                this.errors.push(name+'は借入予定金額以下で入力してください。');
                this.errorFocus('fwt_borrow_bonus');
            }
        }
        
        // 内、ボーナスで返済する割合又は金額
        name = '「内、ボーナスで返済する割合又は金額」';
        if($('fwt_borrow_bonus_rate').value != '' && $('fwt_borrow_bonus').value != '') {
            this.errors.push(name+'はいずれか一方のみを入力してください。');
            this.errorFocus('fwt_borrow_bonus');
        }
        
        // 金利
        name = '「金利」';
        if($('fwt_debt_rate1').value == '') {
            this.errors.push(name+'を入力してください。');
            this.errorFocus('fwt_debt_rate1');
        }
        else {
            var err = this.checkNumber($('fwt_debt_rate1').value,2,2);
            if(err) {
                this.errors.push(name+'は'+err);
                this.errorFocus('fwt_debt_rate1');
            }
        }
        // 繰上返済予定
        name = '「繰上返済予定」';
        if(parseInt($('fwt_advance_year').value) > parseInt($('fwt_borrow_year').value)) {
            this.errors.push(name+'は「返済期間」以下を入力してください。');
            this.errorFocus('fwt_advance_year');
        }
        
        // 借入予定金額
        name = '「繰上返済予定金額」';
        if($('fwt_advance_money').value == '') {
            this.errors.push(name+'を入力してください。');
            this.errorFocus('fwt_advance_money');
        }
        else {
            var err = this.checkNumber($('fwt_advance_money').value,6,0);
            if(err) {
                this.errors.push(name+'は'+err);
                this.errorFocus('fwt_advance_money');
            }
        }
    },
    // 数値チェック
    checkNumber: function(val,int_length,dec_length) {
        // 空
        if(val == '') {
            return '数値を入力してください。';
        }
        // 数字とカンマ以外
        if(val.match(/[^0-9|^.]/g)) {
            return '数値を入力してください。';
        }
        // カンマの数
        var cnt = 0;
        for(var i=0; i<val.length; i++) {
            if(val.charAt(i) == '.') {
                cnt++;
            }
        }
        if(cnt > 1) {
            return '正しい数値を入力してください。';
        }
        // 先頭カンマ
        if(val.charAt(0) == '.') {
            return '正しい数値を入力してください。';
        }
        // 整数部分の桁数
        if(int_length > 0) {
            var int_str = '';
            if(cnt == 1) {
                int_str = val.substring(0, val.indexOf('.'));
            }
            else {
                int_str = val;
            }
            if(int_str.length > int_length) {
                return '整数部分を'+int_length+'桁以下で入力してください。';
            }
        }
        // 小数部分の桁数
        if(dec_length > 0) {
            var dec_str = '';
            if(cnt == 1) {
                var idx = val.indexOf('.');
                dec_str = val.substring(idx);
                if(dec_str.length-1 > dec_length) {
                    return '小数部分を'+dec_length+'桁以下で入力してください。';
                }
            }
        }
        else {
            if(cnt == 1) {
                return '整数を入力してください。';
            }
        }
        return false;
    },
    // 全角数字＆ドットを半角に置換
    replaceZennumToHannum: function(chars) {
        var zennums = new Array('０','１','２','３','４','５','６','７','８','９','．');
        var hannums = new Array(0,1,2,3,4,5,6,7,8,9,'.');
        for(var i=0; i<11; i++) {
            chars = chars.replace(new RegExp(zennums[i],'g'),hannums[i]); 
        }
        return chars;
    },
    // カンマ付加
    addComma: function(str) {
        var num = new String(str).replace(/,/g, "");
        while(num != (num = num.replace(/^(-?\d+)(\d{3})/, "$1,$2")));
        return num;
    },
    // アラート出力
    alerts: function() {
        if(this.errors.length > 0) {
            var txt = '';
            for(var i=0; i<this.errors.length; i++) {
                txt += this.errors[i]+"\n";
            }
            if(this.error_elm != '') {
                $(this.error_elm).focus();
            }
            alert(txt);
        }
    },
    // エラー要素へのフォーカス
    errorFocus: function(elm) {
        if(this.error_elm == '') {
            this.error_elm = elm;
        }
    }
});

document.observe('dom:loaded', function() {

    // 出力スペースの要素名
    var elm = 'fwt_kuriage';
    
    if($(elm)) {
        new kuriage(elm);
    }
});


